<?php

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class RedstampModelFatture extends JModelList {

    public function __construct($config = array()) {
        $config['filter_fields'] = array(
            'ordering',
            'search'
        );
        parent::__construct($config);
        $mainframe = JFactory::getApplication();
        $this->limit = $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $this->limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $this->limitstart = ($this->limit != 0 ? (floor($this->limitstart / $this->limit) * $this->limit) : 0);

        $this->setState('limit', $this->limit);
        $this->setState('limitstart', $this->limitstart);
    }

    public function getItems() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query, $this->limitstart, $this->limit);
        $results = $db->loadObjectList();
        return $results;
    }

    public function getTotal() {
        $db = JFactory::getDBO();
        $query = $this->costruisciQuery();
        $db->setQuery($query);
        $db->query();
        $results = $db->getNumRows();
        return $results;
    }

    protected function populateState($ordering = null, $direction = null) {
        $app = JFactory::getApplication('administrator');

        $search = $app->getUserStateFromRequest($this->context . '.filter.search', 'filter_search');
        //Omit double (white-)spaces and set state
        $this->setState('filter.search', preg_replace('/\s+/', ' ', $search));
        parent::populateState('ordering', 'ASC');
    }

    public function costruisciQuery() {
        //$filterCompanyName = JRequest::getVar('filterCompanyName');

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $search = $db->escape($this->getState('filter.search'));
        $query->select("f.*, a.email")
                ->from("#__redstamp_fatture f")
                ->innerJoin("#__redstamp_anagrafiche a ON a.idAnagrafica = f.idAnagrafica")
                ->order("nFattura DESC")
                ->limit($this->limitstart . ", " . $this->limit);

        return $query;
    }

    function pubblica() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelperHelper::pubblica($ids, $type);

        return $return;
    }

    function sospendi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelperHelper::sospendi($ids, $type);

        return $return;
    }

    function rimuovi() {
        $ids = JRequest::getVar("ids");
        $type = JRequest::getVar("type");

        $return = osmaHelperHelper::rimuovi($ids, $type);

        return $return;
    }

    function salva() {
        $type = JRequest::getVar("type");
        $return = osmaHelperHelper::salva($type);

        echo $return;
    }

    function getFattura($idFattura) {

        $db = JFactory::getDBO();
        $query = $db->getQuery(true);

        $query->select("*")
                ->from("#__redstamp_fatture f")
                ->where("idFattura = {$idFattura}")
                ->order("idFattura DESC");
        $db->setQuery($query);

        $array = $db->loadObject();
        $array->prodotti = unserialize($array->prodotti);
        

        return $array;
    }

}
